module jp.ku6.windows.win32api.propidl;

import core.stdc.string;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.winbase;
import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.oaidl;
import jp.ku6.windows.win32api.objidl;
import jp.ku6.windows.win32api.rpcdcep;

extern (Windows):

struct VERSIONEDSTREAM
{
	GUID guidVersion;
	IStream pStream;
}
alias VERSIONEDSTREAM* LPVERSIONEDSTREAM;

immutable DWORD PROPSETFLAG_DEFAULT        = 0;
immutable DWORD PROPSETFLAG_NONSIMPLE      = 1;
immutable DWORD PROPSETFLAG_ANSI           = 2;
immutable DWORD PROPSETFLAG_UNBUFFERED     = 4;
immutable DWORD PROPSETFLAG_CASE_SENSITIVE = 8;

immutable DWORD PROPSET_BEHAVIOR_CASE_SENSITIVE = 1;

struct CAC
{
	ULONG cElems;
	CHAR* pElems;
}

struct CAUB
{
	ULONG cElems;
	UCHAR* pElems;
}

struct CAI
{
	ULONG cElems;
	SHORT* pElems;
}

struct CAUI
{
	ULONG cElems;
	USHORT* pElems;
}

struct CAL
{
	ULONG cElems;
	LONG* pElems;
}

struct CAUL
{
	ULONG cElems;
	ULONG* pElems;
}

struct CAFLT
{
	ULONG cElems;
	FLOAT* pElems;
}

struct CADBL
{
	ULONG cElems;
	DOUBLE* pElems;
}

struct CACY
{
	ULONG cElems;
	CY* pElems;
}

struct CADATE
{
	ULONG cElems;
	DATE* pElems;
}

struct CABSTR
{
	ULONG cElems;
	BSTR* pElems;
}

struct CABSTRBLOB
{
	ULONG cElems;
	BSTRBLOB* pElems;
}

struct CABOOL
{
	ULONG cElems;
	VARIANT_BOOL* pElems;
}

struct CASCODE
{
	ULONG cElems;
	SCODE* pElems;
}

struct CAPROPVARIANT
{
	ULONG cElems;
	PROPVARIANT* pElems;
}

struct CAH
{
	ULONG cElems;
	LARGE_INTEGER* pElems;
}

struct CAUH
{
	ULONG cElems;
	ULARGE_INTEGER* pElems;
}

struct CALPSTR
{
	ULONG cElems;
	LPSTR* pElems;
}

struct CALPWSTR
{
	ULONG cElems;
	LPWSTR* pElems;
}

struct CAFILETIME
{
	ULONG cElems;
	FILETIME* pElems;
}

struct CACLIPDATA
{
	ULONG cElems;
	CLIPDATA* pElems;
}

struct CACLSID
{
	ULONG cElems;
	CLSID* pElems;
}

alias BYTE PROPVAR_PAD1;
alias BYTE PROPVAR_PAD2;
alias ULONG PROPVAR_PAD3;

struct PROPVARIANT
{
	VARTYPE vt;
	PROPVAR_PAD1 wReserved1;
	PROPVAR_PAD2 wReserved2;
	PROPVAR_PAD3 wReserved3;
	union 
	{
		CHAR cVal;
		UCHAR bVal;
		SHORT iVal;
		USHORT uiVal;
		LONG lVal;
		ULONG ulVal;
		INT intVal;
		UINT uintVal;
		LARGE_INTEGER hVal;
		ULARGE_INTEGER uhVal;
		FLOAT fltVal;
		DOUBLE dblVal;
		VARIANT_BOOL boolVal;
		SCODE scode;
		CY cyVal;
		DATE date;
		FILETIME filetime;
		CLSID* puuid;
		CLIPDATA* pclipdata;
		BSTR bstrVal;
		BSTRBLOB bstrblobVal;
		BLOB blob;
		LPSTR pszVal;
		LPWSTR pwszVal;
		IUnknown punkVal;
		IDispatch pdispVal;
		IStream pStream;
		IStorage pStorage;
		LPVERSIONEDSTREAM pVersionedStream;
		LPSAFEARRAY parray;
		CAC cac;
		CAUB caub;
		CAI cai;
		CAUI caui;
		CAL cal;
		CAUL caul;
		CAH cah;
		CAUH cauh;
		CAFLT caflt;
		CADBL cadbl;
		CABOOL cabool;
		CASCODE cascode;
		CACY cacy;
		CADATE cadate;
		CAFILETIME cafiletime;
		CACLSID cauuid;
		CACLIPDATA caclipdata;
		CABSTR cabstr;
		CABSTRBLOB cabstrblob;
		CALPSTR calpstr;
		CALPWSTR calpwstr;
		CAPROPVARIANT capropvar;
		CHAR* pcVal;
		UCHAR* pbVal;
		SHORT* piVal;
		USHORT* puiVal;
		LONG* plVal;
		ULONG* pulVal;
		INT* pintVal;
		UINT* puintVal;
		FLOAT* pfltVal;
		DOUBLE* pdblVal;
		VARIANT_BOOL* pboolVal;
		DECIMAL* pdecVal;
		SCODE* pscode;
		CY* pcyVal;
		DATE* pdate;
		BSTR* pbstrVal;
		IUnknown* ppunkVal;
		IDispatch* ppdispVal;
		LPSAFEARRAY* pparray;
		PROPVARIANT* pvarVal;
	}
}

alias PROPVARIANT* LPPROPVARIANT;
alias const(PROPVARIANT)* REFPROPVARIANT;

immutable DWORD PID_DICTIONARY         = 0;
immutable DWORD PID_CODEPAGE           = 0x1;
immutable DWORD PID_FIRST_USABLE       = 0x2;
immutable DWORD PID_FIRST_NAME_DEFAULT = 0xfff;
immutable DWORD PID_LOCALE             = 0x80000000;
immutable DWORD PID_MODIFY_TIME        = 0x80000001;
immutable DWORD PID_SECURITY           = 0x80000002;
immutable DWORD PID_BEHAVIOR           = 0x80000003;
immutable DWORD PID_ILLEGAL            = 0xffffffff;
immutable DWORD PID_MIN_READONLY       = 0x80000000;
immutable DWORD PID_MAX_READONLY       = 0xbfffffff;

immutable DWORD PIDDI_THUMBNAIL = 0x00000002;

immutable DWORD PIDSI_TITLE        = 0x00000002;
immutable DWORD PIDSI_SUBJECT      = 0x00000003;
immutable DWORD PIDSI_AUTHOR       = 0x00000004;
immutable DWORD PIDSI_KEYWORDS     = 0x00000005;
immutable DWORD PIDSI_COMMENTS     = 0x00000006;
immutable DWORD PIDSI_TEMPLATE     = 0x00000007;
immutable DWORD PIDSI_LASTAUTHOR   = 0x00000008;
immutable DWORD PIDSI_REVNUMBER    = 0x00000009;
immutable DWORD PIDSI_EDITTIME     = 0x0000000a;
immutable DWORD PIDSI_LASTPRINTED  = 0x0000000b;
immutable DWORD PIDSI_CREATE_DTM   = 0x0000000c;
immutable DWORD PIDSI_LASTSAVE_DTM = 0x0000000d;
immutable DWORD PIDSI_PAGECOUNT    = 0x0000000e;
immutable DWORD PIDSI_WORDCOUNT    = 0x0000000f;
immutable DWORD PIDSI_CHARCOUNT    = 0x00000010;
immutable DWORD PIDSI_THUMBNAIL    = 0x00000011;
immutable DWORD PIDSI_APPNAME      = 0x00000012;
immutable DWORD PIDSI_DOC_SECURITY = 0x00000013;

immutable DWORD PIDDSI_CATEGORY    = 0x00000002;
immutable DWORD PIDDSI_PRESFORMAT  = 0x00000003;
immutable DWORD PIDDSI_BYTECOUNT   = 0x00000004;
immutable DWORD PIDDSI_LINECOUNT   = 0x00000005;
immutable DWORD PIDDSI_PARCOUNT    = 0x00000006;
immutable DWORD PIDDSI_SLIDECOUNT  = 0x00000007;
immutable DWORD PIDDSI_NOTECOUNT   = 0x00000008;
immutable DWORD PIDDSI_HIDDENCOUNT = 0x00000009;
immutable DWORD PIDDSI_MMCLIPCOUNT = 0x0000000A;
immutable DWORD PIDDSI_SCALE       = 0x0000000B;
immutable DWORD PIDDSI_HEADINGPAIR = 0x0000000C;
immutable DWORD PIDDSI_DOCPARTS    = 0x0000000D;
immutable DWORD PIDDSI_MANAGER     = 0x0000000E;
immutable DWORD PIDDSI_COMPANY     = 0x0000000F;
immutable DWORD PIDDSI_LINKSDIRTY  = 0x00000010;

immutable DWORD PIDMSI_EDITOR      = 0x00000002;
immutable DWORD PIDMSI_SUPPLIER    = 0x00000003;
immutable DWORD PIDMSI_SOURCE      = 0x00000004;
immutable DWORD PIDMSI_SEQUENCE_NO = 0x00000005;
immutable DWORD PIDMSI_PROJECT     = 0x00000006;
immutable DWORD PIDMSI_STATUS      = 0x00000007;
immutable DWORD PIDMSI_OWNER       = 0x00000008;
immutable DWORD PIDMSI_RATING      = 0x00000009;
immutable DWORD PIDMSI_PRODUCTION  = 0x0000000A;
immutable DWORD PIDMSI_COPYRIGHT   = 0x0000000B;

enum PIDMSI_STATUS_VALUE
{
	PIDMSI_STATUS_NORMAL,
	PIDMSI_STATUS_NEW,
	PIDMSI_STATUS_PRELIM,
	PIDMSI_STATUS_DRAFT,
	PIDMSI_STATUS_INPROGRESS,
	PIDMSI_STATUS_EDIT,
	PIDMSI_STATUS_REVIEW,
	PIDMSI_STATUS_PROOF,
	PIDMSI_STATUS_FINAL,
	PIDMSI_STATUS_OTHER = 0x7fff
}

immutable DWORD PRSPEC_INVALID = 0xffffffff;
immutable DWORD PRSPEC_LPWSTR  = 0;
immutable DWORD PRSPEC_PROPID  = 1;

struct PROPSPEC
{
	ULONG ulKind;
	union 
	{
		PROPID propid;
		LPOLESTR lpwstr;
	}
}

struct STATPROPSTG
{
	LPOLESTR lpwstrName;
	PROPID propid;
	VARTYPE vt;
}

WORD PROPSETHDR_OSVER_KIND(DWORD dwOSVer)
{
	return HIWORD(dwOSVer);
}

BYTE PROPSETHDR_OSVER_MAJOR(DWORD dwOSVer)
{
	return LOBYTE(LOWORD(dwOSVer));
}

BYTE PROPSETHDR_OSVER_MINOR(DWORD dwOSVer)
{
	return HIBYTE(LOWORD(dwOSVer));
}

immutable DWORD PROPSETHDR_OSVERSION_UNKNOWN = 0xFFFFFFFF;

struct STATPROPSETSTG
{
	FMTID fmtid;
	CLSID clsid;
	DWORD grfFlags;
	FILETIME mtime;
	FILETIME ctime;
	FILETIME atime;
	DWORD dwOSVersion;
}

immutable IID IID_IPropertyStorage = {0x00000138, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPropertyStorage : IUnknown
{
	HRESULT ReadMultiple(ULONG cpspec, const(PROPSPEC)* rgpspec, PROPVARIANT* rgpropvar);
	HRESULT WriteMultiple(ULONG cpspec, const(PROPSPEC)* rgpspec, const(PROPVARIANT)* rgpropvar, PROPID propidNameFirst);
	HRESULT DeleteMultiple(ULONG cpspec, const(PROPSPEC)* rgpspec);
	HRESULT ReadPropertyNames(ULONG cpropid, const(PROPID)* rgpropid, LPOLESTR* rglpwstrName);
	HRESULT WritePropertyNames(ULONG cpropid, const(PROPID)* rgpropid, const(LPOLESTR)* rglpwstrName);
	HRESULT DeletePropertyNames(ULONG cpropid, const(PROPID)* rgpropid);
	HRESULT Commit(DWORD grfCommitFlags);
	HRESULT Revert();
	HRESULT Enum(IEnumSTATPROPSTG* ppenum);
	HRESULT SetTimes(const(FILETIME)* pctime, const(FILETIME)* patime, const(FILETIME)* pmtime);
	HRESULT SetClass(REFCLSID clsid);
	HRESULT Stat(STATPROPSETSTG* pstatpsstg);
}
alias IPropertyStorage LPPROPERTYSTORAGE;

immutable IID IID_IPropertySetStorage = {0x0000013A, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPropertySetStorage : IUnknown
{
	HRESULT Create(REFFMTID rfmtid, const(CLSID)* pclsid, DWORD grfFlags, DWORD grfMode, IPropertyStorage* ppprstg);
	HRESULT Open(REFFMTID rfmtid, DWORD grfMode, IPropertyStorage* ppprstg);
	HRESULT Delete(REFFMTID rfmtid);
	HRESULT Enum(IEnumSTATPROPSETSTG* ppenum);
}

immutable IID IID_IEnumSTATPROPSTG = {0x00000139, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumSTATPROPSTG : IUnknown
{
	HRESULT Next(ULONG celt, STATPROPSTG* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumSTATPROPSTG* ppenum);
}
alias IEnumSTATPROPSTG LPENUMSTATPROPSTG;


HRESULT IEnumSTATPROPSTG_RemoteNext_Proxy(IEnumSTATPROPSTG This, ULONG celt, STATPROPSTG* rgelt, ULONG* pceltFetched);
void IEnumSTATPROPSTG_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IEnumSTATPROPSETSTG = {0x0000013B, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumSTATPROPSETSTG : IUnknown
{
	HRESULT Next(ULONG celt, STATPROPSETSTG* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumSTATPROPSETSTG* ppenum);
}
alias IEnumSTATPROPSETSTG LPENUMSTATPROPSETSTG;

HRESULT IEnumSTATPROPSETSTG_RemoteNext_Proxy(IEnumSTATPROPSETSTG This, ULONG celt, STATPROPSETSTG* rgelt, ULONG* pceltFetched);
void IEnumSTATPROPSETSTG_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

HRESULT PropVariantCopy(PROPVARIANT* pvarDest, const(PROPVARIANT)* pvarSrc);
HRESULT PropVariantClear(PROPVARIANT* pvar);
HRESULT FreePropVariantArray(ULONG cVariants, PROPVARIANT* rgvars);

void PropVariantInit(PROPVARIANT* pvar)
{
    memset(pvar, 0, PROPVARIANT.sizeof);
}

HRESULT StgCreatePropStg(IUnknown pUnk, REFFMTID fmtid, const(CLSID)* pclsid, DWORD grfFlags, DWORD dwReserved, IPropertyStorage* ppPropStg);
HRESULT StgOpenPropStg(IUnknown pUnk, REFFMTID fmtid, DWORD grfFlags, DWORD dwReserved, IPropertyStorage* ppPropStg);
HRESULT StgCreatePropSetStg(IStorage pStorage, DWORD dwReserved, IPropertySetStorage* ppPropSetStg);

immutable DWORD CCH_MAX_PROPSTG_NAME = 31;

HRESULT FmtIdToPropStgName(const(FMTID)* pfmtid, LPOLESTR oszName);
HRESULT PropStgNameToFmtId(const(LPOLESTR) oszName, FMTID* pfmtid);

struct SERIALIZEDPROPERTYVALUE
{
    DWORD dwType;
    BYTE[1] rgb;
}


extern (C)
{
	SERIALIZEDPROPERTYVALUE* StgConvertVariantToProperty(const(PROPVARIANT)* pvar, USHORT CodePage, SERIALIZEDPROPERTYVALUE* pprop, ULONG* pcb, PROPID pid, BOOLEAN fReserved, ULONG* pcIndirect);

	struct PMemoryAllocator
	{
	}

	BOOLEAN StgConvertPropertyToVariant(const(SERIALIZEDPROPERTYVALUE)* pprop, USHORT CodePage, PROPVARIANT* pvar, PMemoryAllocator* pma);
}

uint BSTR_UserSize(uint* pFlags, uint Offset, BSTR* pBstr);
ubyte* BSTR_UserMarshal(uint* pFlags, ubyte* pBuffer, BSTR* pBstr);
ubyte* BSTR_UserUnmarshal(uint* pFlags, ubyte* pBuffer, BSTR* pBstr);
void BSTR_UserFree(uint* pFlags, BSTR* pBstr);

uint LPSAFEARRAY_UserSize(uint* pFlags, uint Offset, LPSAFEARRAY* pSafearray);
ubyte* LPSAFEARRAY_UserMarshal(uint* pFlags, ubyte* pBuffer, LPSAFEARRAY* pSafearray);
ubyte* LPSAFEARRAY_UserUnmarshal(uint* pFlags, ubyte* pBuffer, LPSAFEARRAY* pSafearray);
void LPSAFEARRAY_UserFree(uint* pFlags, LPSAFEARRAY* pSafearray); 

uint BSTR_UserSize64(uint* pFlags, uint Offset, BSTR* pBstr);
ubyte* BSTR_UserMarshal64(uint* pFlags, ubyte* pBuffer, BSTR* pBstr);
ubyte* BSTR_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, BSTR* pBstr);
void BSTR_UserFree64(uint* pFlags, BSTR* pBstr);

uint LPSAFEARRAY_UserSize64(uint* pFlags, uint Offset, LPSAFEARRAY* pSafearray);
ubyte* LPSAFEARRAY_UserMarshal64(uint* pFlags, ubyte* pBuffer, LPSAFEARRAY* pSafearray);
ubyte* LPSAFEARRAY_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, LPSAFEARRAY* pSafearray);
void LPSAFEARRAY_UserFree64(uint* pFlags, LPSAFEARRAY* pSafearray);

HRESULT IEnumSTATPROPSTG_Next_Proxy(IEnumSTATPROPSTG This, ULONG celt, STATPROPSTG* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATPROPSTG_Next_Stub(IEnumSTATPROPSTG This, ULONG celt, STATPROPSTG* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATPROPSETSTG_Next_Proxy(IEnumSTATPROPSETSTG This, ULONG celt, STATPROPSETSTG* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATPROPSETSTG_Next_Stub(IEnumSTATPROPSETSTG This, ULONG celt, STATPROPSETSTG* rgelt, ULONG *pceltFetched);
